using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_General._1_Datos
{
    public class PRV_LicenciaDatos_Datos
    {
        #region Obtener
        public PRV_LicenciaDatos Obtener()
        {
            Exferia_Entities obj_Exferia_Entities = null;

            PRV_LicenciaDatos mdl_PRV_LicenciaDatos = null;
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                    " SELECT " +
                        nameof(PRV_LicenciaDatos.id) + "," +
                        nameof(PRV_LicenciaDatos.idCliente) + "," +
                        nameof(PRV_LicenciaDatos.nombreComercial) + "," +
                        nameof(PRV_LicenciaDatos.razonSocial) +
                    " FROM " + nameof(PRV_LicenciaDatos);

                //Rellenar el Modelo
                mdl_PRV_LicenciaDatos = obj_Exferia_Entities.Database.SqlQuery<PRV_LicenciaDatos>(str_SQL, new object[] { }).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                mdl_PRV_LicenciaDatos = null;
                throw new Control_Errores("", ex, nameof(PRV_LicenciaDatos_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_PRV_LicenciaDatos;
        }
        #endregion


        #region Grabar
        public INTERNO_ValorDevuelto_Modelo Grabar(PRV_LicenciaDatos _mdl_PRV_LicenciaDatos)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Tipo de Accion que se va a realizar
                mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                #region DELETE
                string str_SQL_Delete = " DELETE FROM " + nameof(PRV_LicenciaDatos);
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete);
                #endregion

                #region INSERT
                string str_SQL_Insert = " INSERT INTO " + nameof(PRV_LicenciaDatos) +
                                            " (" +
                                                    nameof(PRV_LicenciaDatos.idCliente) + "," +
                                                    nameof(PRV_LicenciaDatos.nombreComercial) + "," +
                                                    nameof(PRV_LicenciaDatos.razonSocial) +
                                            " ) " +
                                            " OUTPUT INSERTED." + nameof(PRV_LicenciaDatos.id) +
                                            " VALUES " +
                                            " ( " +
                                                "@idCliente," +
                                                "@nombreComercial," +
                                                "@razonSocial" +
                                            " ) ";
                //Parametros
                object[] arr_Parametros_Insert = new object[]
                {
                    new SqlParameter("@idCliente",  _mdl_PRV_LicenciaDatos.idCliente),
                    new SqlParameter("@nombreComercial",  _mdl_PRV_LicenciaDatos.nombreComercial),
                    new SqlParameter("@razonSocial",  _mdl_PRV_LicenciaDatos.razonSocial)
                };
                #endregion

                //Id de la tabla
                mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
             
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRV_LicenciaDatos_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
